import java.util.*;
import java.net.*;
import java.io.*;

public class DemuxerServer {
	Vector readers = new Vector();
	DataOutputStream out = new DataOutputStream(System.out);
	
	public static void main(String [] args) {
		DemuxerServer demux = new DemuxerServer();
		demux.setPort(Integer.parseInt(args[0]));
		demux.startServer();
	}
	int port = 8000;
	String host = "127.0.0.1";
	void setPort(int v) {
		port = v;
	}
	int getPort() {
		return port;
	}
	void setHost(String v) {
		host = v;
	}
	String getHost() {
		return host;
	}
	void startServer() {
		ServerSocket serv = null;
		try {
			serv = new ServerSocket(getPort());
		} catch (IOException e) {
			System.err.println("Could not listen on port: "+getPort()+" "+e.getMessage());
			System.exit(1);
		}
		ReaderThread readerThread = new ReaderThread();
		boolean first = true;
		if (first) {
			first = false;
			readerThread.start();
		}
		Socket clientSocket = null;
		while (true) {
			try {
				clientSocket = serv.accept();
				DataInputStream b = new DataInputStream(new BufferedInputStream(clientSocket.getInputStream()));
				readers.add(b);
				System.err.println("Accepting connection:"+clientSocket);

			} catch (IOException e) {
				System.err.println(e.getMessage());
			}
		}
	}
	Vector getReadersCopy() {
		return new Vector(readers);
	}
	class ReaderThread extends Thread {
		public void run() {
			try {
			int size = 4096;
			short [] outBuffer = new short[size];
			//byte [] byteOutBuffer = new byte[2*size];
		
			while (true) {
				Vector readers = getReadersCopy();
				int total = readers.size();
				boolean first =true;
				Iterator iter = readers.iterator();
				int ind = 0;
				short currs = 0;
				short currs2 =0 ;
				short currs3 =0;
				while (iter.hasNext()) {
					DataInputStream curr = (DataInputStream)iter.next();
					if (curr.available() >= 2*size)  {
					try {
						if (first) {
							for (int i = 0; i < size; i++) {
								currs = curr.readShort();
								currs2 = (short)((currs << 8) & 0xFF00);
								currs3 = (short)((currs >> 8) & 0x00FF);
								currs =  (short)(currs2 | currs3);
								outBuffer[i] = (short)(currs/total);
							}
							first =false;
						} else {
							for (int i = 0; i < size; i++) {
								currs = curr.readShort();
								currs2 = (short)((currs << 8)&(0xFF00));
								currs3 = (short)((currs >> 8)&(0x00FF));
								currs = (short)(currs2 | currs3);
								outBuffer[i] += (short)(currs/total);
							}
						}
					} catch (IOException e) {
						iter.remove();
					}
					} else {
						iter.remove();
					}
					ind++;
				}
				if (size == 0) {
					for (int i = 0; i < size; i++) {
						outBuffer[i] =0;
					}
				}
				first = true;
				for (int i =0; i < size; i++) {
					currs = outBuffer[i];
					currs2 = (short)((currs << 8) & (0xFF00));
					currs3 = (short)((currs >> 8) & (0x00FF));
					currs =  (short)(currs2 | currs3);
					out.writeShort(currs);
				}
				//for (int i = 0; i < 4096; i++) {
				//	short hi = outBuffer[i];
				//	byteOutBuffer[2*i + 1] = (byte) (hi & 0xFF);
                        	//	byteOutBuffer[2*i + 0] = (byte) ((hi >>> 8) & 0xFF);
				//}
				//if (total > 0) {
					System.err.println("Write Block");
					//out.write(byteOutBuffer);
				//}
			}
			} catch (IOException e) {
				System.err.println(e);
				System.exit(1);
			}
		}
	}
	
}
